// Iterator-Pattern:
// Collection fr beliebig viele Auto-Objekte

import java.util.*;

interface AutoIterator {
  public boolean hasNext();
  public Auto next();
}

class AutoArray {
   private Vector autoVektor = new Vector() ;

   public void addAuto(Auto neuesAuto) {
      autoVektor.addElement(neuesAuto) ;
   }

   // Iterator als anonyme innere Klasse
   public AutoIterator getElements() {
      return new AutoIterator() {
         private int index = 0;
         public boolean hasNext() {
            return index < autoVektor.size();
         }

         public Auto next() {
            return (Auto) autoVektor.elementAt(index++);
         }
      };
   }
}

public class TestAutoArray2 {
   public static void main(String[] args) {
      //Collection erzeugen
      Auto a1 = new Auto("VW", "BN 12345", 1990);
      Auto a2 = new Auto("VW", "SU-AB 52", 2000);
      Auto a3 = new Auto("Opel", "FR-AU 123", 2001);
      Auto a4 = new Auto("Ford", "K-P 512", 1990);
      AutoArray autoListe = new AutoArray() ;
      autoListe.addAuto(a1) ;
      autoListe.addAuto(a2) ;
      autoListe.addAuto(a3) ;
      autoListe.addAuto(a4) ;

      //Iterator beschaffen und Elemente durchlaufen
      AutoIterator liste = autoListe.getElements();

      while (liste.hasNext()) {
         liste.next().druckeObjekt() ;
      }
   }
}
